local function TrainFuck( ply, cmd, args )

	if evolve and evolve.installed then
	
		if not ply:EV_IsAdmin() then return end
		
	else
	
		if not ply:IsAdmin() then return end
		
	end
	
	local _a = args or {}
	local _t = tostring( string.Implode( " ", _a ) )
	
	for k, v in pairs( player.GetAll() ) do
	
		if v:Nick():lower():find( _t:lower() ) then
			
			local targetvect = Vector( 0, 900, 50 )
			local targetpos = v:GetPos() + targetvect
			
			
			local train = ents.Create( "prop_physics" )
			train:SetModel( "models/props_vehicles/train_boxcar.mdl" )
			train:SetAngles( Angle( 0, 90,0 ) )
			train:SetPos( targetpos )
			train:Spawn()
			train:EmitSound( "ambient/alarms/train_horn2.wav", 100, 100 )
			train:GetPhysicsObject():SetVelocity( v:GetForward() / 50000 - Vector( 0, 10000, 0 ) )
			
			timer.Simple( 5, function() train:Remove() end )
			
		end
		
	end
	
end
concommand.Add( "trainfuck", TrainFuck )

local function TruckFuck( ply, cmd, args )

	if evolve and evolve.installed then
	
		if not ply:EV_IsAdmin() then return end
		
	else
	
		if not ply:IsAdmin() then return end
		
	end
	
	local _a = args or {}
	local _t = tostring( string.Implode( " ", _a ) )
	
	for k, v in pairs( player.GetAll() ) do
	
		if v:Nick():lower():find( _t:lower() ) then
			
			local targetvect = v:GetPos()
			local targetpos = v:GetPos() + targetvect
			
			
			local train = ents.Create( "prop_physics" )
			train:SetModel( "models/props_vehicles/truck001a.mdl" )
			train:SetAngles( Angle( 60, 225,0 ) )
			train:SetPos( v:GetPos() + Vector(500,500,3500) )
			train:Spawn()
			constraint.NoCollide(train,GetWorldEntity(),0,0)
			v:EmitSound( "ambient/alarms/train_horn2.wav", 100, 100 )
			train:GetPhysicsObject():SetVelocity( (((targetvect - train:GetPos())*10) * train:GetPhysicsObject():GetMass()) * 1)
			
			timer.Simple( 5, function() train:Remove() end )
			
		end
		
	end
	
end
concommand.Add( "truckfuck", TruckFuck )


--Thank you Polly for this awesome chat command framework ;D
local short = "blag"

local function IsColor( col )
	return col and type( col ) == "table" and col.r and col.g and col.b and col.a
end

local function Notify( pl, ... )
	if SERVER then
		local args = { ... }
		umsg.Start( "globeBase[Notify]", pl )
			umsg.Short( #args )
			for k,v in ipairs( args ) do
				if IsColor( v ) then
					umsg.String( string.format( "C[%d/%d/%d/%d]", v.r, v.g, v.b, v.a ) )
				elseif type( v ) == "Player" and v:IsPlayer() then
					umsg.String( v:Name() )
				else
					umsg.String( tostring( v ) )
				end
			end
		umsg.End()
	else
		chat.AddText( Color( 120, 200, 120 ), "[" .. short .. "] ", Color( 180, 180, 255 ), ... )
	end
end

if CLIENT then
	usermessage.Hook( "globeBase[Notify]", function( um )
		local args = {}
		for i=1,um:ReadShort() do
			local str = um:ReadString()
			local r,g,b,a = str:match( "C%[(\d-)/(\d-)/(\d-)/(\d-)%]" )
			if r and g and b and a then
				table.insert( args, Color( r, g, b, a ) )
			else
				table.insert( args, tostring( str ) )
			end
		end
		Notify( nil, unpack( args ) )
	end )
end

local function Meta( tbl )
	tbl.__index = tbl
	tbl.__metatable = {}
	return setmetatable( tbl, {
		__call = function( self, tbl )
			return setmetatable( tbl, self )
		end
	} )
end

local _C = Meta {}

AccessorFunc( _C, "Command", "Command", FORCE_STRING )
AccessorFunc( _C, "Function", "Function" )

function _C:__tostring()
	return string.format( "[Command: %s]", self.Command )
end

function _C:Run( pl, ... )
	local ret = self:GetFunction()( pl, ... )
	if ret and ret != "" then
		Notify( pl, ret )
	end
end

function _C:Remove()
	commands[self.Command] = nil
end

local commands = {}
Command = {}

function Command.Add( cmd, func )
	if not cmd or not func then return end
	local tbl = _C {}
	tbl:SetCommand( cmd )
	tbl:SetFunction( func )
	commands[cmd] = tbl
	return tbl
end

function Command.GetAll()
	return commands
end

function Command.Get( cmd )
	return Command.GetAll()[cmd]
end

concommand.Add( short, function( pl, cmd, args )
	local c = args[1]
	
	if not c then return end
	table.remove( args, 1 )
	
	local cmd = Command.Get( c )
	if not cmd then
		Notify( pl, "Invalid command ", c )
		return
	end
	
	cmd:Run( pl, unpack( args ) )
end )

hook.Add( "PlayerSay", "globeBase[PlayerSay]", function( pl, text, public )
	local txt = text
	local prefix = txt:sub( 1,1 )
	if prefix != "!" and prefix != "/" then return end
	
	txt = txt:sub(2, txt:len() )

	local cmd = txt:match( "^(%S+)" )
	txt = txt:gsub( "^(%S+)", "", 1 )
	if cmd == txt then return "" end
	
	if not Command.Get( cmd ) then
		Notify( pl, "Invalid command ", cmd )
		return ""
	end
	
	local quote = txt:sub( 1, 1 ) ~= '"'
	local ret = {}
	for chunk in txt:gmatch( '[^"]+' ) do
		quote = not quote
		if quote then
			table.insert( ret, chunk )
		else
			for chunk in chunk:gmatch( "%S+" ) do
				table.insert( ret, chunk )
			end
		end
	end
	
	Command.Get( cmd ):Run( pl, unpack( ret ) )
	
	return (prefix == "!") and text or ""
end )

Command.Add( "trainfuck", function( pl, target )
	if not target then return end
	pl:ConCommand( "trainfuck " .. target )
end )

Command.Add( "truckfuck", function( pl, target )
	if not target then return end
	pl:ConCommand( "truckfuck " .. target )
end )
